

(* -------------------------------------------------------------------- *)
(*									*)
(*		NewTest4.ml						*)
(*									*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(* 	Functions							*)
(* -------------------------------------------------------------------- *)

dec_elab "val var f1 = fn var x1 => var x1";
by elab_tac;

exp_elab "let val var f1 = fn var x1 => var x1 in var f1 end";
by elab_tac;

exp_elab "let val var f1 = fn var x1 => var x1 in \
     \ var f1 ` var f1 end";
by elab_tac;

exp_elab "(- fn var x1 => var x1 -)` scon n ";
by elab_tac;

exp_elab "(- fn var x1 => scon n -)` scon m "; 
by elab_tac;
 
dec_elab "val var f1 = fn var x1 => \
 \ fn var x2 => (- var x1,var x2 -) ";
by elab_tac;
 
exp_elab "let val var f1 = fn var x1 => fn var x2 => \
   \  (- var x1, var x2 -) in (- var f1` scon m -)` scon n  end";
by elab_tac;

(* Makepair - type should be the same as the previous f1 *)

dec_elab "val var f2 = \
    \ fn var x1 => let val var x3 = var x1 in fn var x2 => \
    \  (- var x3, var x2 -) end ";
by elab_tac;

(* -------------------------------------------------------------------- *)
(* 	Pattern Matching						*)
(* -------------------------------------------------------------------- *)

exp_elab "let val var f1 = fn scon 0 => scon 0 | _ => scon succ(0) \
\         in var f1 ` scon 0 end";
by elab_tac;

exp_elab "let val var f1 = fn scon 0 => scon 0 | _ => scon succ(0) \
\         in var f1 ` scon succ(0) end";
by elab_tac;

exp_elab "let val var f1 = \
\ fn (-var x1, scon succ (0)-) => var x1 | _  => scon 0 \
     \  in var f1 ` (-scon r, scon succ (0)-) end";
by elab_tac;

exp_elab "let val var f1 = \
\  fn (-var x1, scon succ (0)-) => var x1 | _  => scon 0 \
     \  in var f1 ` (-scon r, scon 0-) end";
by elab_tac;

(* -------------------------------------------------------------------- *)
(* 	 This is a famous nasty LISP example  				*)
(* 	- p311 in Winston & Horn					*)
(*	Note that x1 appears as both a bound and a free variable!	*)
(* -------------------------------------------------------------------- *)

exp_elab
 "let val var x1 = scon m;	\
  \   val var f1 = fn var f3 => fn var x1 => \
  \          (- var f3` (- var f3 ` var x1 -)-); \
  \   val var f2 = fn var x2 => (- var x2 ** var x1 -) in \
  \      (-var f1 ` var f2 -)` scon n end";
by elab_tac;

