(* -------------------------------------------------------------------- *)
(*									*)
(*		Test5.ml						*)
(*									*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(*	Recursion							*)
(* -------------------------------------------------------------------- *)

dec_elab "val rec var f1 = fn var x1 => (- var f1 ` var x1 -)"; 
                                            (* brackets needed here ! *)
by elab_tac;

exp_elab   "let val rec var f1 = fn var x1 => \
  \ if zero var x1 then scon succ (0) else \
  \ (- var x1 ** (- var f1 ` (- var x1 -- scon succ (0) -)-)-) in \
  \  var f1 ` scon 0 end";
by elab_tac;

exp_elab   "let val rec var f1 = fn var x1 => \
  \ if zero var x1 then scon succ (0) else \
  \ (- var x1 ** (- var f1 ` (- var x1 -- scon succ (0) -)-)-) in \
  \  var f1 ` scon succ (0)  end";
by elab_tac;

exp_elab   "let val rec var f1 = fn var x1 => \
  \ if zero var x1 then scon succ (0) else \
  \ (- var x1 ** (- var f1 ` (- var x1 -- scon succ (0) -)-)-) in \
  \  var f1 ` scon succ (succ(0))  end";
by elab_tac;

(* -------------------------------------------------------------------- *)
(*	Lists and Polymorphism						*)
(* -------------------------------------------------------------------- *)

exp_elab   "let val var x1 = [scon a, scon b] in var x1 end";
by elab_tac;

exp_elab   "let val var x1 = [scon a, scon b] in head var x1 end";
by elab_tac;

exp_elab   "let val var x1 = [scon a, scon b] in tail var x1 end";
by elab_tac;

exp_elab   
"let val var x1 = [scon a, scon b] in head tail var x1 end";
by elab_tac;

exp_elab   "scon d :: scon e :: []";
by elab_tac;

exp_elab   "[scon d, scon e]";
by elab_tac;

exp_elab   "[]";
by elab_tac;

exp_elab   
"let val var x1 = [scon a, scon b]; \
\    val var x2 = scon m in var x2 :: var x1 end";
by elab_tac;

exp_elab   "let val var x1 = [] in null var x1 end";
by elab_tac;

exp_elab   "let val var x1 = [scon a, scon b] in null var x1 end";
by elab_tac;

exp_elab   
"let val var x1 = [scon a, scon b]; \
\    val var f1 = fn var x2 => head var x2 \
\ in      \
\    var f1 ` var x1 end";
by elab_tac;

exp_elab   "[]::[]";
by elab_tac;

(* In this example, f1 is the append function *)

exp_elab  
  "let val var x1 = [scon a, scon b]; \
  \    val rec var f1 = fn var x1 => fn var x2 => \
  \  if null var x1 then var x2 else \
  \  (- (-head var x1-) :: (-(-var f1-)`(-tail var x1-)`(-var x2-)-)-) in \
  \    (-var f1 ` (-var x1-)-) ` var x1 end";
by elab_tac;


(* In this example, f1 is the reverse function *)

exp_elab  
    "let   val var x1 = [scon a, scon b]; \
 \         val rec var f1 = \
 \            fn var x2 => fn var x1 => if null var x2 then var x1  \
 \                    else  (-(- var f1 ` (-tail var x2-)-) ` \
 \                     (- head var x2 :: var x1 -)-) in \  
 \      (-var f1 ` var x1 -) ` [] end";
by elab_tac;




 





