(* -------------------------------------------------------------*)
(*								*)
(*		elab_dec.thy:					*)
(*								*)
(* ------------------------------------------------------------ *)

elab_dec = elab_mrule +

rules

Val       "(EX VE VE' VE''. C ||-  valbind ~> VE [ValBind] & VE = VE' &   \
\          Close (C, VE') = VE'' &  <0, 0, VE'', 0> = E') <->  \
\          C ||- val valbind ~>  E' "	(* -- Rule 17 *)

Type_     "(EX TE. C ||- typbind ~> TE [TypBind] & <0, TE, 0, 0> = E) <->  \
\           C ||- type typbind ~> E" (* Rule 18 *)

DataType  
     "(EX TE VE C'. C  ## <0, 0, 0, TE, 0, 0> = C' & \
\      C' ||- datbind ~> VE, TE [DatBind] &  <0, TE, VE, 0> = E) \
\     <->  C ||- datatype datbind ~> E" (* Rule 19 *)

AbsType  
     "(EX TE VE E C' C''.  C' ||- datbind ~> VE, TE [DatBind] & \
\     C ## <0, 0, 0, TE, 0, 0> = C' & \
\     C ## <0, 0, 0, TE, VE, 0> = C'' & \
\  C'' ||- dec ~> E &  ABS (TE,E, E'))  <->  \
\  C ||- abstype datbind with dec end  ~> E'" (* Rule 20 *)

Exception "(EX EE VE. C ||- exbind ~> EE [ExBind] &  \
\           EE = VE & <0, 0, VE, EE> = E) <->  \
\          C ||- exception exbind ~> E"  (* Rule 21 *)

Local	"(EX E1 C'. C ||- dec1 ~> E1 &  C ## <0, 0, E1> = C' & \
\        C' ||- dec2 ~> E2) <-> \
\        C ||- local dec1 in dec2 end ~> E2"	(* Rule 22 *)
						(* Rule 23 omitted *)

Nothing	"<0, 0, 0, 0> = E <-> C ||- nothing ~> E" (* Rule 24 *)

Comp1   "(EX E E' C'. C ||- dec ~> E & C ## <0, 0, E> = C'\
\          & C' ||- dec' ~> E' & \
\         E # E' = E'') <-> C ||-  dec  dec' ~> E''"     (* Rule 25a *)

Comp2   "(EX E E' C'. C ||- dec ~> E & C ## <0, 0, E> = C'\
\          & C' ||- dec' ~> E' & \
\         E # E' = E'') <-> C ||-  dec ; dec' ~> E''"     (* Rule 25b *)


end
