(* -------------------------------------------------------------*)
(*								*)
(*		eval_atpat.thy:					*)
(*								*)
(* ------------------------------------------------------------ *)

eval_atpat = eval_valbind +

rules

					(* Rule 140  *)
Wild_Pat     "<VarEnv, 0> = VE' <-> E, v ||- _ ~> VE' [Pat]"
					(* -- Rules 141,142  *)
Scon_Pat     "((<SVal, n> = v & <VarEnv, 0> = VE') |  \
\              (~<SVal, n> = v & FAIL = VE')) <-> \
\             E, v ||- scon n ~>  VE' [Pat]"
					(* Rule 143  *)
Var_Pat      "<VarEnv, {<<Var, x>,v>}> = VE' <-> E, v ||- var x ~> VE'  [Pat]"
					(* -- Rules 144,145  *)
Con_Pat      "((<Con, c> = v & <VarEnv, 0> = VE') | \
\              (~<Con, c> = v & FAIL = VE' )) <-> \
\             E, v ||- con c ~> VE' [Pat]" 
					(* -- Rules 146,147  *)
ExCon_Pat    "((EX SE VE EE. E = <SE,VE,EE> & \
\            EE`<ExCon, e> = v &  <VarEnv, 0> = VE') | \
\           (EX SE VE EE. E = <SE,VE,EE> & \
\            ~ EE`<ExCon, e> = v & FAIL = VE' )) <-> \
\           E, v ||- excon e ~> VE' [Pat]" 
				(* Rule 148a *)

Empty_Record_Pat  "<VarEnv, Record, 0> = VE'  <-> \
\                  E, <Record, 0> ||- {{}} ~> VE' [Pat]"
				(* -- Rule 148 *)

Record_Pat     "E, r ||- patrow ~> VE' [PatRow] \
\           <-> E, r ||- {{patrow}} ~> VE' [Pat]" 
					(* -- Rule 149a *)

Bracket_Pat    "E, v ||- pat ~> VE' [Pat] \
\           <-> E, v ||- (- pat -) ~> VE' [Pat]"


end
