
(* -------------------------------------------------------------*)
(*		More_Arith.ML: 					*)
(*		Further Derived Rules for Arith			*)
(* 		 - includes modified arith_rews			*)
(* ------------------------------------------------------------ *)

val tacfun = fn prems => 
   [cut_facts_tac prems 1, asm_simp_tac (arith_ss addsimps prems) 1];


val add_succ_equality = prove_goal Arith.thy 
  "[| m #+ n = k; succ(k) = k' |]  ==> succ(m) #+ n = k'" tacfun;
 
val mult_succ_equality = prove_goal Arith.thy 
  "[| m #* n = r; n #+ r = k |]  ==> succ(m) #* n = k" tacfun;

val diff_succ_succ_equality = prove_goal Arith.thy 
  "[| m : nat; n : nat; m #- n =  k |]  ==> succ(m) #- succ(n) = k" tacfun;

val arith_rules = [nat_0I, nat_succI, add_0, add_succ_equality,
                  mult_0, mult_succ_equality,
                  diff_0, diff_0_eq_0, 
                  diff_succ_succ_equality];


